"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var common_1 = require('@angular/common');
var XActionsheet = (function () {
    function XActionsheet() {
        this._options = {
            show: false,
            menus: [],
            onSelect: function (key) { },
            onCancel: function () { },
            cancelText: 'Cancel'
        };
    }
    XActionsheet.prototype.emitEvent = function (event, key) {
        if (event === 'menu') {
            this._options.onSelect(key);
        }
        if (event === 'cancel') {
            this._options.onCancel();
        }
        this.hide();
    };
    XActionsheet.prototype.hide = function () {
        this.options.show = false;
    };
    XActionsheet.prototype.ngOnChanges = function (changes) {
        if ('options' in changes) {
            var current = changes['options'].currentValue;
            // onSelect and onCancel are special
            if (typeof current.onSelect === 'function') {
                this._options.onSelect = current.onSelect;
            }
            if (typeof current.onCancel === 'function') {
                this._options.onCancel = current.onCancel;
                this.options.showCancel = true;
            }
            if (typeof current.cancelText !== 'string') {
                this.options.cancelText = this._options.cancelText;
            }
            else {
                this.options.showCancel = true;
            }
        }
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], XActionsheet.prototype, "options", void 0);
    XActionsheet = __decorate([
        core_1.Component({
            selector: 'x-actionsheet',
            encapsulation: core_1.ViewEncapsulation.None,
            inputs: [
                'menus'
            ],
            template: require('./actionsheet.html'),
            styles: [
                require('./actionsheet.less')
            ]
        }), 
        __metadata('design:paramtypes', [])
    ], XActionsheet);
    return XActionsheet;
}());
exports.XActionsheet = XActionsheet;
var XActionsheetModule = (function () {
    function XActionsheetModule() {
    }
    XActionsheetModule = __decorate([
        core_1.NgModule({
            declarations: [
                XActionsheet
            ],
            imports: [
                common_1.CommonModule
            ],
            exports: [
                XActionsheet,
                common_1.CommonModule
            ]
        }), 
        __metadata('design:paramtypes', [])
    ], XActionsheetModule);
    return XActionsheetModule;
}());
exports.XActionsheetModule = XActionsheetModule;
//# sourceMappingURL=actionsheet.js.map