"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var utils_1 = require('../utils');
var XButton = (function () {
    function XButton(_elementRef, _renderer) {
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this._color = 'default';
        this.options = {
            isPlain: false
        };
        this._options = {};
    }
    XButton.prototype.ngDoCheck = function () {
        var oldPlain = this._options.isPlain;
        var newPlain = this.options.isPlain;
        if (oldPlain !== newPlain) {
            utils_1.updateClass(this._renderer, this._elementRef, oldPlain ? "weui_btn_plain_" + this.color : '', false);
            this._options.isPlain = newPlain;
            utils_1.updateClass(this._renderer, this._elementRef, newPlain ? "weui_btn_plain_" + this.color : '', true);
        }
        var oldSize = this._options.size;
        var newSize = this.options.size;
        if (oldSize !== newSize) {
            utils_1.updateClass(this._renderer, this._elementRef, "weui_btn_" + oldSize, false);
            this._options.size = newSize;
            utils_1.updateClass(this._renderer, this._elementRef, "weui_btn_" + newSize, true);
        }
    };
    XButton.prototype.ngOnInit = function () {
        utils_1.updateClass(this._renderer, this._elementRef, 'weui_btn', true);
    };
    Object.defineProperty(XButton.prototype, "color", {
        get: function () {
            return this._color;
        },
        set: function (value) {
            utils_1.updateClass(this._renderer, this._elementRef, "weui_btn_" + this._color, false);
            this._color = value;
            utils_1.updateClass(this._renderer, this._elementRef, "weui_btn_" + this._color, true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XButton.prototype, "disabled", {
        get: function () {
            return this._disabled;
        },
        set: function (value) {
            utils_1.updateClass(this._renderer, this._elementRef, this._disabled ? 'weui_btn_disabled' : '', false);
            this._disabled = value;
            utils_1.updateClass(this._renderer, this._elementRef, this._disabled ? 'weui_btn_disabled' : '', true);
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], XButton.prototype, "options", void 0);
    XButton = __decorate([
        core_1.Component({
            selector: 'button[x-button]',
            encapsulation: core_1.ViewEncapsulation.None,
            inputs: [
                'color',
                'disabled'
            ],
            template: require('./button.html'),
            styles: [
                require('./button.less')
            ]
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.Renderer])
    ], XButton);
    return XButton;
}());
exports.XButton = XButton;
var XButtonModule = (function () {
    function XButtonModule() {
    }
    XButtonModule = __decorate([
        core_1.NgModule({
            declarations: [
                XButton
            ],
            exports: [
                XButton
            ]
        }), 
        __metadata('design:paramtypes', [])
    ], XButtonModule);
    return XButtonModule;
}());
exports.XButtonModule = XButtonModule;
//# sourceMappingURL=button.js.map