"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var common_1 = require('@angular/common');
var inline_desc_1 = require('../inline-desc');
var icon_1 = require('../icon');
var utils_1 = require('../utils');
var INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return XInput; }),
    multi: true
};
var nextUniqueId = 0;
var XInput = (function () {
    function XInput(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.autofocus = false;
        this.disabled = false;
        this.max = null;
        this.maxlength = null;
        this.min = null;
        this.minlength = null;
        this.placeholder = '';
        this.readonly = false;
        this.required = false;
        this.tabindex = null;
        this.type = 'text'; // text number password
        this.name = null;
        this.id = "x-input-" + nextUniqueId++;
    }
    Object.defineProperty(XInput.prototype, "inputId", {
        get: function () {
            return this.id + "-input";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XInput.prototype, "value", {
        get: function () {
            return this._innerValue;
        },
        set: function (v) {
            if (v !== this._innerValue) {
                this._innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    XInput.prototype.writeValue = function (v) {
        if (v !== this._innerValue) {
            this._innerValue = v;
        }
    };
    XInput.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    XInput.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    XInput.prototype.ngOnInit = function () {
        utils_1.updateClass(this._renderer, this._elementRef, 'weui_cell', true);
        if (this.vcode) {
            utils_1.updateClass(this._renderer, this._elementRef, 'weui_vcode', true);
        }
    };
    XInput.prototype.clear = function () {
        this.value = null;
    };
    __decorate([
        core_1.Input('aria-label'), 
        __metadata('design:type', String)
    ], XInput.prototype, "ariaLabel", void 0);
    __decorate([
        core_1.Input('aria-labelledby'), 
        __metadata('design:type', String)
    ], XInput.prototype, "ariaLabelledBy", void 0);
    __decorate([
        core_1.Input('aria-disabled'),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "ariaDisabled", void 0);
    __decorate([
        core_1.Input('aria-required'),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "ariaRequired", void 0);
    __decorate([
        core_1.Input('aria-invalid'),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "ariaInvalid", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "autocomplete", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "autocorrect", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "autocapitalize", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "autofocus", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], XInput.prototype, "max", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XInput.prototype, "maxlength", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], XInput.prototype, "min", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XInput.prototype, "minlength", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "readonly", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "required", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XInput.prototype, "tabindex", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "type", void 0);
    __decorate([
        // text number password
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "name", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "title", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "subTitle", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "showClear", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XInput.prototype, "vcode", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XInput.prototype, "id", void 0);
    XInput = __decorate([
        core_1.Component({
            selector: 'x-input',
            encapsulation: core_1.ViewEncapsulation.None,
            template: require('./input.html'),
            styles: [
                require('./input.less')
            ],
            providers: [
                INPUT_CONTROL_VALUE_ACCESSOR
            ]
        }), 
        __metadata('design:paramtypes', [core_1.Renderer, core_1.ElementRef])
    ], XInput);
    return XInput;
}());
exports.XInput = XInput;
var XInputModule = (function () {
    function XInputModule() {
    }
    XInputModule = __decorate([
        core_1.NgModule({
            declarations: [
                XInput
            ],
            imports: [
                forms_1.FormsModule,
                common_1.CommonModule,
                inline_desc_1.InlineDescModule,
                icon_1.XIconModule
            ],
            exports: [
                XInput,
                forms_1.FormsModule,
                common_1.CommonModule,
                inline_desc_1.InlineDescModule,
                icon_1.XIconModule
            ]
        }), 
        __metadata('design:paramtypes', [])
    ], XInputModule);
    return XInputModule;
}());
exports.XInputModule = XInputModule;
//# sourceMappingURL=input.js.map