"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var platform_browser_1 = require('@angular/platform-browser');
var common_1 = require('@angular/common');
var inline_desc_1 = require('../inline-desc');
var utils_1 = require('../utils');
var SWITCH_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return XSwitch; }),
    multi: true
};
var XSwitch = (function () {
    function XSwitch(_sanitizer, _renderer, _elementRef) {
        this._sanitizer = _sanitizer;
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this._title = '';
        this._innerValue = false;
        this.labelStyle = {};
        this.subTitle = '';
    }
    Object.defineProperty(XSwitch.prototype, "title", {
        get: function () {
            var html = this._sanitizer.bypassSecurityTrustHtml(this._title);
            return html;
        },
        set: function (value) {
            this.labelStyle = genLabelStyle(value);
            this._title = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XSwitch.prototype, "value", {
        get: function () {
            return this._innerValue;
        },
        set: function (v) {
            if (v !== this._innerValue) {
                this._innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    XSwitch.prototype.writeValue = function (v) {
        if (v !== this._innerValue) {
            this._innerValue = v;
        }
    };
    XSwitch.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    XSwitch.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    XSwitch.prototype.ngOnInit = function () {
        utils_1.updateClass(this._renderer, this._elementRef, 'weui_cell', true);
        utils_1.updateClass(this._renderer, this._elementRef, 'weui_cell_switch', true);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XSwitch.prototype, "subTitle", void 0);
    XSwitch = __decorate([
        core_1.Component({
            selector: 'x-switch',
            encapsulation: core_1.ViewEncapsulation.None,
            inputs: [
                'title'
            ],
            template: require('./switch.html'),
            styles: [
                require('./switch.less')
            ],
            providers: [
                SWITCH_CONTROL_VALUE_ACCESSOR
            ]
        }), 
        __metadata('design:paramtypes', [platform_browser_1.DomSanitizer, core_1.Renderer, core_1.ElementRef])
    ], XSwitch);
    return XSwitch;
}());
exports.XSwitch = XSwitch;
var XSwitchModule = (function () {
    function XSwitchModule() {
    }
    XSwitchModule = __decorate([
        core_1.NgModule({
            declarations: [
                XSwitch
            ],
            imports: [
                forms_1.FormsModule,
                common_1.CommonModule,
                inline_desc_1.InlineDescModule
            ],
            exports: [
                XSwitch,
                forms_1.FormsModule,
                common_1.CommonModule,
                inline_desc_1.InlineDescModule
            ]
        }), 
        __metadata('design:paramtypes', [])
    ], XSwitchModule);
    return XSwitchModule;
}());
exports.XSwitchModule = XSwitchModule;
function genLabelStyle(title) {
    var isHTML = /<\/?[^>]*>/.test(title);
    var width = Math.min(isHTML ? 5 : (title.length + 1), 12) + 'em';
    return {
        width: width
    };
}
//# sourceMappingURL=switch.js.map