"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var forms_1 = require('@angular/forms');
var common_1 = require('@angular/common');
var utils_1 = require('../utils');
var TEXTAREA_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return XTextarea; }),
    multi: true
};
var XTextarea = (function () {
    function XTextarea(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.autofocus = false;
        this.disabled = false;
        this.maxlength = null;
        this.minlength = null;
        this.placeholder = '';
        this.readonly = false;
        this.required = false;
        this.tabindex = null;
        this.rows = null;
        this.cols = null;
        // add
        this.showCounter = true;
        this.count = 0;
    }
    Object.defineProperty(XTextarea.prototype, "value", {
        get: function () {
            return this._innerValue;
        },
        set: function (v) {
            if (v !== this._innerValue) {
                this.count = v.length;
                this._innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    XTextarea.prototype.writeValue = function (v) {
        if (v !== this._innerValue) {
            if (v) {
                this.count = v.length;
            }
            this._innerValue = v;
        }
    };
    XTextarea.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    XTextarea.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    XTextarea.prototype.ngOnInit = function () {
        utils_1.updateClass(this._renderer, this._elementRef, 'weui_cell', true);
    };
    __decorate([
        core_1.Input('aria-label'), 
        __metadata('design:type', String)
    ], XTextarea.prototype, "ariaLabel", void 0);
    __decorate([
        core_1.Input('aria-labelledby'), 
        __metadata('design:type', String)
    ], XTextarea.prototype, "ariaLabelledBy", void 0);
    __decorate([
        core_1.Input('aria-disabled'),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "ariaDisabled", void 0);
    __decorate([
        core_1.Input('aria-required'),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "ariaRequired", void 0);
    __decorate([
        core_1.Input('aria-invalid'),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "ariaInvalid", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XTextarea.prototype, "autocomplete", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XTextarea.prototype, "autocorrect", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XTextarea.prototype, "autocapitalize", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "autofocus", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XTextarea.prototype, "maxlength", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XTextarea.prototype, "minlength", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], XTextarea.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "readonly", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "required", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XTextarea.prototype, "tabindex", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XTextarea.prototype, "rows", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], XTextarea.prototype, "cols", void 0);
    __decorate([
        core_1.Input(),
        utils_1.BooleanFieldValue(), 
        __metadata('design:type', Boolean)
    ], XTextarea.prototype, "showCounter", void 0);
    XTextarea = __decorate([
        core_1.Component({
            selector: 'x-textarea',
            encapsulation: core_1.ViewEncapsulation.None,
            template: require('./textarea.html'),
            styles: [
                require('./textarea.less')
            ],
            providers: [
                TEXTAREA_CONTROL_VALUE_ACCESSOR
            ]
        }), 
        __metadata('design:paramtypes', [core_1.Renderer, core_1.ElementRef])
    ], XTextarea);
    return XTextarea;
}());
exports.XTextarea = XTextarea;
var XTextareaModule = (function () {
    function XTextareaModule() {
    }
    XTextareaModule = __decorate([
        core_1.NgModule({
            declarations: [
                XTextarea
            ],
            imports: [
                forms_1.FormsModule,
                common_1.CommonModule
            ],
            exports: [
                XTextarea,
                forms_1.FormsModule,
                common_1.CommonModule
            ]
        }), 
        __metadata('design:paramtypes', [])
    ], XTextareaModule);
    return XTextareaModule;
}());
exports.XTextareaModule = XTextareaModule;
//# sourceMappingURL=textarea.js.map